=== debian/changelog ===
criu (2.0-2ubuntu3) xenial; urgency=medium

  * Apply a couple of fixes to work with the Ubuntu kernel:
    - restore: don't pass cgroup nsroot= option to mount()
    - restore: correctly restore cgroup mounts inside a container

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 30 Mar 2016 11:51:33 -0400

criu (2.0-2ubuntu2) xenial; urgency=medium

  * Cherry-pick upstream fixes:
    - restore: zombies should collect their children
    - mount: ignore subvol argument in btrfs sb
    - namespaces: zero struct ns_id when allocating

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 23 Mar 2016 13:06:09 -0400

criu (2.0-2ubuntu1) xenial; urgency=medium

  * Make it build with Ubuntu hardening (LP: #1555861)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 10 Mar 2016 18:54:46 -0500

criu (2.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 08 Mar 2016 21:14:24 +0100

criu (2.0-1) experimental; urgency=medium

  * Imported Upstream version 2.0
  * Add Build-Depends on libnl-3-dev
  * Add Build-Depends on libcap-dev
  * Use HTTPS transport protocol for Vcs-Git URI
  * Update copyright years for debian/* packaging files
  * Declare compliance with Debian policy 3.9.7
  * debian/copyright: Update file paths after upstream file reorganisation
  * Sync manpage for crit to include short explanation for new subcommands

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 07 Mar 2016 20:19:11 +0100
