## criu 2.2

=== Documentation/Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 A2X		:= a2x
 XMLTO		:= xmlto
 
+FOOTER		:= footer.txt
 SRC		+= criu.txt
 XMLS		:= $(patsubst %.txt,%.xml,$(SRC))
 MANS		:= $(patsubst %.txt,%.8,$(SRC))
@@ -26,6 +27,16 @@
 		$$B --version > /dev/null || exit 1;	\
 	done
 
+$(FOOTER): ../Makefile.versions
+	$(call msg-gen, $@)
+	$(Q) echo ":doctype:       manpage"		>  $@
+	$(Q) echo ":man source:    criu"		>> $@
+	$(Q) echo ":man version:   $(CRIU_VERSION)"	>> $@
+	$(Q) echo ":man manual:    CRIU Manual"		>> $@
+
+$(SRC): $(FOOTER)
+	@true
+
 %.8: %.txt
 	$(call msg-gen, $@)
 	$(Q) $(ASCIIDOC) -b docbook -d manpage -o $(patsubst %.8,%.xml,$@) $<
@@ -41,11 +52,15 @@
 
 clean:
 	$(call msg-clean, "Documentation")
-	$(Q) rm -f $(XMLS) $(MANS) $(PSS) $(PDFS)
+	$(Q) rm -f $(XMLS) $(MANS) $(PSS) $(PDFS) $(FOOTER)
 
 install: $(MANS)
 	$(E) "  INSTALL " $(MANS)
 	$(Q) mkdir -p $(DESTDIR)$(MAN8DIR)
 	$(Q) install -m 644 $(MANS) $(DESTDIR)$(MAN8DIR)
 
-.PHONY: clean install
+uninstall:
+	$(E) " UNINSTALL" $(MANS)
+	$(Q) $(RM) $(addprefix $(DESTDIR)$(MAN8DIR)/,$(MANS))
+
+.PHONY: clean install uninstall
