=== criu/Makefile ===
--- 
+++ 
@@ -5,6 +5,10 @@
 HOSTLD			?= ld
 HOSTCFLAGS		?= $(CFLAGS)
 CFLAGS			+= $(USERCFLAGS)
+
+# here is a workaround for a bug in libnl-3:
+# 6a8d90f5fec4 "attr: Allow attribute type 0" 
+WRAPFLAGS		+= -Wl,--wrap=nla_parse,--wrap=nlmsg_parse
 
 export HOSTCC HOSTLD HOSTCFLAGS
 
@@ -56,18 +60,47 @@
 export ccflags-y
 
 LIBS			:= -lrt -lpthread -lprotobuf-c -ldl -lnl-3
-REQ-LIBS-NAMES          := libpthread libprotobuf-c libnl-3
+
+REQ-RPM-PKG-NAMES	+= protobuf
+REQ-RPM-PKG-NAMES	+= protobuf-c
+REQ-RPM-PKG-NAMES	+= protobuf-c-devel
+REQ-RPM-PKG-NAMES	+= protobuf-compiler
+REQ-RPM-PKG-NAMES	+= protobuf-devel
+REQ-RPM-PKG-NAMES	+= protobuf-python
+REQ-RPM-PKG-NAMES	+= libnl3-devel
+
+REQ-DEB-PKG-NAMES	+= libprotobuf-dev
+REQ-DEB-PKG-NAMES	+= libprotobuf-c0-dev
+REQ-DEB-PKG-NAMES	+= protobuf-c-compiler
+REQ-DEB-PKG-NAMES	+= protobuf-compiler
+REQ-DEB-PKG-NAMES	+= python-protobuf
+REQ-DEB-PKG-NAMES	+= libnl-3-dev
+
+REQ-RPM-PKG-TEST-NAMES  += libaio-devel
+REQ-RPM-PKG-TEST-NAMES  += libcap-devel
+
+REQ-DEB-PKG-TEST-NAMES  += libaio-dev
+REQ-DEV-PKG-TEST-NAMES  += libcap-dev
 
 #
 # Make sure all required libs are installed
 ifneq ($(MAKECMDGOALS),clean)
+ifneq ($(MAKECMDGOALS),mrproper)
         ifneq ($(shell sh -c                                                            \
                         'TMP="$(OUTPUT)$(TMPOUT).$$$$";                                 \
                         echo "int main(int argc, char *argv[]) { return 0; }" |         \
                         "$(CC)" -x c - $(LIBS) -o "$$TMP" > /dev/null 2>&1 && echo y;   \
                         rm -f "$$TMP"'),y)
-                $(error "Make sure '$(REQ-LIBS-NAMES)' libraries are installed")
+                $(warning "Couldn't find some of the required libraries")
+                $(warning "Make sure the following packages are installed")
+                $(warning "RPM based distros: $(REQ-RPM-PKG-NAMES)")
+                $(warning "DEB based distros: $(REQ-DEB-PKG-NAMES)")
+                $(warning "To run tests the following packages are needed")
+                $(warning "RPM based distros: $(REQ-RPM-PKG-TEST-NAMES)")
+                $(warning "DEB based distros: $(REQ-DEB-PKG-TEST-NAMES)")
+                $(error "Compilation aborted")
         endif
+endif
 endif
 ifeq ($(GMON),1)
 	CFLAGS		+= -pg
@@ -144,24 +177,40 @@
 
 criu: $(PROGRAM-BUILTINS)
 	$(call msg-link, $@)
-	$(Q) $(CC) $(CFLAGS) $^ $(SYSCALL-LIB) $(ARCH-LIB) $(LIBS) $(LDFLAGS) $(GMONLDOPT) -rdynamic -o $@
-
-#
-# Cleanup everything.
-clean:
+	$(Q) $(CC) $(CFLAGS) $^ $(ARCH-LIB) $(LIBS) $(WRAPFLAGS) $(LDFLAGS) $(GMONLDOPT) -rdynamic -o $@
+
+
+subclean:
+	$(Q) $(RM) ./*.{gcda,gcno,gcov}
+	$(Q) $(RM) ./pie/*.{gcda,gcno,gcov}
+	$(Q) $(RM) ./pie/piegen/*.{gcda,gcno,gcov}
+	$(Q) $(RM) -r ./gcov
+	$(Q) $(RM) criu
+.PHONY: subclean
+
+#
+# Clean the most, except generated c files
+clean: subclean
 	$(Q) $(MAKE) $(call build-as,Makefile.syscalls,$(ARCH_DIR)) $@
+	$(Q) $(MAKE) $(call build-as,Makefile,$(ARCH_DIR)) $@
 	$(Q) $(MAKE) $(call build-as,Makefile.library,pie) $@
 	$(Q) $(MAKE) $(call build-as,Makefile.crtools,.) $@
 	$(Q) $(MAKE) $(build)=pie/piegen $@
 	$(Q) $(MAKE) $(build)=pie $@
-	$(Q) $(RM) ./*.{gcda,gcno,gcov}
-	$(Q) $(RM) ./pie/*.{gcda,gcno,gcov}
-	$(Q) $(RM) ./pie/piegen/*.{gcda,gcno,gcov}
-	$(Q) $(RM) -r ./gcov
+.PHONY: clean
+
+#
+# Delete all generated files
+mrproper: subclean
+	$(Q) $(MAKE) $(call build-as,Makefile.syscalls,$(ARCH_DIR)) $@
+	$(Q) $(MAKE) $(call build-as,Makefile,$(ARCH_DIR)) $@
+	$(Q) $(MAKE) $(call build-as,Makefile.library,pie) $@
+	$(Q) $(MAKE) $(call build-as,Makefile.crtools,.) $@
+	$(Q) $(MAKE) $(build)=pie/piegen $@
+	$(Q) $(MAKE) $(build)=pie $@
 	$(Q) $(RM) $(VERSION_HEADER)
 	$(Q) $(RM) $(CONFIG_HEADER)
-	$(Q) $(RM) criu
-.PHONY: clean
+.PHONY: mrproper
 
 UAPI_HEADERS := include/criu-plugin.h include/criu-log.h
 
@@ -173,6 +222,12 @@
 	$(Q) install -m 644 $(UAPI_HEADERS) $(DESTDIR)$(INCLUDEDIR)
 .PHONY: install
 
+uninstall:
+	$(E) " UNINSTALL" criu
+	$(Q) $(RM) $(addprefix $(DESTDIR)$(SBINDIR)/,criu)
+	$(Q) $(RM) $(addprefix $(DESTDIR)$(INCLUDEDIR)/,$(notdir $(UAPI_HEADERS)))
+.PHONY: uninstall
+
 #
 # Final @all target.
 all: criu
