=== debian/changelog ===
criu (2.2-1) unstable; urgency=medium

  * Imported Upstream version 2.2
  * Drop build-Don-t-pass-wrap-on-every-linking-file-only-for.patch

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 20 May 2016 14:18:04 +0200

criu (2.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 12 May 2016 17:22:37 +0200

criu (2.1-1) experimental; urgency=medium

  * Imported Upstream version 2.1
  * Declare compliance with Debian policy 3.9.8
  * Don't pass --wrap on every linking file only for CRIU target only

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 05 May 2016 14:28:03 +0200
