=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: criu
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
+Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends:
  asciidoc,
  debhelper (>= 9.20151219),
@@ -15,7 +14,7 @@
  protobuf-compiler,
  python-all (>= 2.6.6-3~),
  xmlto
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://www.criu.org/
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/criu.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/criu.git
