=== debian/rules ===
--- 
+++ 
@@ -14,10 +14,6 @@
 	# /usr/lib/systemd/system should not be installed
 	find $(TMP)/usr/lib -type d -empty -delete
 
-override_dh_auto_build:
-	# CRIU doesn't talk to the linker through gcc
-	LDFLAGS=-Bsymbolic-functions dh_auto_build
-
 override_dh_auto_test:
 	# disabled: doesn't work yet
