## criu 2.5

=== debian/changelog ===
criu (2.5-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 19 Aug 2016 10:24:28 +0200

criu (2.5-1) experimental; urgency=medium

  * Imported Upstream version 2.5

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 16 Aug 2016 15:34:44 +0200

criu (2.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 22 Jul 2016 14:12:06 +0200

criu (2.4-1) experimental; urgency=low

  * Imported Upstream version 2.4
  * Add copyright information for new included file
  * Set LIBEXECDIR to /usr/lib during installation of files.
    Make sure that systemd-autofs-restart.sh helper is installed into
    /usr/lib/criu/scripts/.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 14 Jul 2016 07:24:53 +0200

criu (2.3-3) unstable; urgency=medium

  * build: nmk -- Filter out -Wl flags from linking builtin targets

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 30 Jun 2016 18:03:48 +0200

criu (2.3-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 28 Jun 2016 15:51:45 +0200

criu (2.3-1) experimental; urgency=medium

  * Imported Upstream version 2.3
  * debian/copyright: Use HTTPS transport protocol for Format URL

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 17 Jun 2016 07:09:17 +0200
